﻿Public Class Form1

    Private YOffset As Long

    Private Sub Form1_Resize(sender As System.Object, e As System.EventArgs) Handles MyBase.Resize
        'テストパターンの描画
        DrawTestPattern()
    End Sub

    Private Sub GraphicsBox1_MouseWheeled(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles GraphicsBox1.MouseWheeled

        ' 表示位置の調整
        YOffset -= e.Delta

        'テストパターンの描画
        DrawTestPattern()

    End Sub

    ''' <summary>
    ''' テストパターンの描画
    ''' </summary>
    ''' <remarks></remarks>
    Private Sub DrawTestPattern()

        ' GraphicsBoxのGraphicsプロパティより取得
        Dim g As Graphics = GraphicsBox1.Graphics
        ' GraphicsBoxのFontsプロパティで設定したフォント
        Dim f As Font = GraphicsBox1.Fonts

        Dim LineStep As Integer = 16

        Dim i As Long
        Dim j As Long

        'クリア
        g.Clear(GraphicsBox1.BackColor)

        For i = (YOffset Mod LineStep) - LineStep To GraphicsBox1.Height Step LineStep

            '線の描画
            g.DrawLine( _
                System.Drawing.Pens.Red, _
                0, _
                i, _
                GraphicsBox1.Width, _
                i)
            For j = i + 1 To i + LineStep - 1 Step 2
                g.DrawLine( _
                    System.Drawing.Pens.Green, _
                    0, _
                    j, _
                    GraphicsBox1.Width, _
                    j)
            Next

            '文字の描画
            g.DrawString( _
                (i - YOffset).ToString(), _
                f, _
                System.Drawing.Brushes.Blue, _
                20, _
                i)

        Next

        '描画更新
        GraphicsBox1.Refresh()
    End Sub

End Class
